# DO NOT EDIT! This file was auto-generated by crates/build/re_types_builder/src/codegen/python/mod.rs
# Based on "crates/store/re_types/definitions/rerun/datatypes/keypoint_id.fbs".

# You can extend this class by creating a "KeypointIdExt" class in "keypoint_id_ext.py".

from __future__ import annotations

from typing import TYPE_CHECKING, Any, Sequence, Union

import numpy as np
import numpy.typing as npt
import pyarrow as pa
from attrs import define, field

from .._baseclasses import (
    BaseBatch,
    BaseExtensionType,
)

__all__ = ["KeypointId", "KeypointIdArrayLike", "KeypointIdBatch", "KeypointIdLike", "KeypointIdType"]


@define(init=False)
class KeypointId:
    """
    **Datatype**: A 16-bit ID representing a type of semantic keypoint within a class.

    `KeypointId`s are only meaningful within the context of a [`rerun.datatypes.ClassDescription`].

    Used to look up an [`rerun.datatypes.AnnotationInfo`] for a Keypoint within the
    [`rerun.components.AnnotationContext`].
    """

    def __init__(self: Any, id: KeypointIdLike):
        """Create a new instance of the KeypointId datatype."""

        # You can define your own __init__ function as a member of KeypointIdExt in keypoint_id_ext.py
        self.__attrs_init__(id=id)

    id: int = field(converter=int)

    def __array__(self, dtype: npt.DTypeLike = None) -> npt.NDArray[Any]:
        # You can define your own __array__ function as a member of KeypointIdExt in keypoint_id_ext.py
        return np.asarray(self.id, dtype=dtype)

    def __int__(self) -> int:
        return int(self.id)

    def __hash__(self) -> int:
        return hash(self.id)


if TYPE_CHECKING:
    KeypointIdLike = Union[KeypointId, int]
else:
    KeypointIdLike = Any

KeypointIdArrayLike = Union[KeypointId, Sequence[KeypointIdLike], int, npt.ArrayLike]


class KeypointIdType(BaseExtensionType):
    _TYPE_NAME: str = "rerun.datatypes.KeypointId"

    def __init__(self) -> None:
        pa.ExtensionType.__init__(self, pa.uint16(), self._TYPE_NAME)


class KeypointIdBatch(BaseBatch[KeypointIdArrayLike]):
    _ARROW_TYPE = KeypointIdType()

    @staticmethod
    def _native_to_pa_array(data: KeypointIdArrayLike, data_type: pa.DataType) -> pa.Array:
        array = np.asarray(data, dtype=np.uint16).flatten()
        return pa.array(array, type=data_type)
