# DO NOT EDIT! This file was auto-generated by crates/build/re_types_builder/src/codegen/python/mod.rs
# Based on "crates/store/re_types/definitions/rerun/datatypes/tensor_buffer.fbs".

# You can extend this class by creating a "TensorBufferExt" class in "tensor_buffer_ext.py".

from __future__ import annotations

from typing import TYPE_CHECKING, Any, Sequence, Union

import numpy as np
import numpy.typing as npt
import pyarrow as pa
from attrs import define, field

from .._baseclasses import (
    BaseBatch,
    BaseExtensionType,
)
from .tensor_buffer_ext import TensorBufferExt

__all__ = ["TensorBuffer", "TensorBufferArrayLike", "TensorBufferBatch", "TensorBufferLike", "TensorBufferType"]


@define
class TensorBuffer(TensorBufferExt):
    """
    **Datatype**: The underlying storage for [`archetypes.Tensor`][rerun.archetypes.Tensor].

    Tensor elements are stored in a contiguous buffer of a single type.
    """

    # You can define your own __init__ function as a member of TensorBufferExt in tensor_buffer_ext.py

    inner: Union[
        npt.NDArray[np.float16],
        npt.NDArray[np.float32],
        npt.NDArray[np.float64],
        npt.NDArray[np.int16],
        npt.NDArray[np.int32],
        npt.NDArray[np.int64],
        npt.NDArray[np.int8],
        npt.NDArray[np.uint16],
        npt.NDArray[np.uint32],
        npt.NDArray[np.uint64],
        npt.NDArray[np.uint8],
    ] = field(
        converter=TensorBufferExt.inner__field_converter_override  # type: ignore[misc]
    )
    """
    Must be one of:

    * U8 (npt.NDArray[np.uint8]):
        8bit unsigned integer.

    * U16 (npt.NDArray[np.uint16]):
        16bit unsigned integer.

    * U32 (npt.NDArray[np.uint32]):
        32bit unsigned integer.

    * U64 (npt.NDArray[np.uint64]):
        64bit unsigned integer.

    * I8 (npt.NDArray[np.int8]):
        8bit signed integer.

    * I16 (npt.NDArray[np.int16]):
        16bit signed integer.

    * I32 (npt.NDArray[np.int32]):
        32bit signed integer.

    * I64 (npt.NDArray[np.int64]):
        64bit signed integer.

    * F16 (npt.NDArray[np.float16]):
        16bit IEEE-754 floating point, also known as `half`.

    * F32 (npt.NDArray[np.float32]):
        32bit IEEE-754 floating point, also known as `float` or `single`.

    * F64 (npt.NDArray[np.float64]):
        64bit IEEE-754 floating point, also known as `double`.
    """


if TYPE_CHECKING:
    TensorBufferLike = Union[
        TensorBuffer,
        npt.NDArray[np.float16],
        npt.NDArray[np.float32],
        npt.NDArray[np.float64],
        npt.NDArray[np.int16],
        npt.NDArray[np.int32],
        npt.NDArray[np.int64],
        npt.NDArray[np.int8],
        npt.NDArray[np.uint16],
        npt.NDArray[np.uint32],
        npt.NDArray[np.uint64],
        npt.NDArray[np.uint8],
    ]
    TensorBufferArrayLike = Union[
        TensorBuffer,
        npt.NDArray[np.float16],
        npt.NDArray[np.float32],
        npt.NDArray[np.float64],
        npt.NDArray[np.int16],
        npt.NDArray[np.int32],
        npt.NDArray[np.int64],
        npt.NDArray[np.int8],
        npt.NDArray[np.uint16],
        npt.NDArray[np.uint32],
        npt.NDArray[np.uint64],
        npt.NDArray[np.uint8],
        Sequence[TensorBufferLike],
    ]
else:
    TensorBufferLike = Any
    TensorBufferArrayLike = Any


class TensorBufferType(BaseExtensionType):
    _TYPE_NAME: str = "rerun.datatypes.TensorBuffer"

    def __init__(self) -> None:
        pa.ExtensionType.__init__(
            self,
            pa.dense_union([
                pa.field("_null_markers", pa.null(), nullable=True, metadata={}),
                pa.field(
                    "U8",
                    pa.list_(pa.field("item", pa.uint8(), nullable=False, metadata={})),
                    nullable=False,
                    metadata={},
                ),
                pa.field(
                    "U16",
                    pa.list_(pa.field("item", pa.uint16(), nullable=False, metadata={})),
                    nullable=False,
                    metadata={},
                ),
                pa.field(
                    "U32",
                    pa.list_(pa.field("item", pa.uint32(), nullable=False, metadata={})),
                    nullable=False,
                    metadata={},
                ),
                pa.field(
                    "U64",
                    pa.list_(pa.field("item", pa.uint64(), nullable=False, metadata={})),
                    nullable=False,
                    metadata={},
                ),
                pa.field(
                    "I8",
                    pa.list_(pa.field("item", pa.int8(), nullable=False, metadata={})),
                    nullable=False,
                    metadata={},
                ),
                pa.field(
                    "I16",
                    pa.list_(pa.field("item", pa.int16(), nullable=False, metadata={})),
                    nullable=False,
                    metadata={},
                ),
                pa.field(
                    "I32",
                    pa.list_(pa.field("item", pa.int32(), nullable=False, metadata={})),
                    nullable=False,
                    metadata={},
                ),
                pa.field(
                    "I64",
                    pa.list_(pa.field("item", pa.int64(), nullable=False, metadata={})),
                    nullable=False,
                    metadata={},
                ),
                pa.field(
                    "F16",
                    pa.list_(pa.field("item", pa.float16(), nullable=False, metadata={})),
                    nullable=False,
                    metadata={},
                ),
                pa.field(
                    "F32",
                    pa.list_(pa.field("item", pa.float32(), nullable=False, metadata={})),
                    nullable=False,
                    metadata={},
                ),
                pa.field(
                    "F64",
                    pa.list_(pa.field("item", pa.float64(), nullable=False, metadata={})),
                    nullable=False,
                    metadata={},
                ),
            ]),
            self._TYPE_NAME,
        )


class TensorBufferBatch(BaseBatch[TensorBufferArrayLike]):
    _ARROW_TYPE = TensorBufferType()

    @staticmethod
    def _native_to_pa_array(data: TensorBufferArrayLike, data_type: pa.DataType) -> pa.Array:
        raise NotImplementedError(
            "Arrow serialization of TensorBuffer not implemented: We lack codegen for arrow-serialization of unions containing lists. Can't handle type rerun.datatypes.TensorBuffer#U8"
        )  # You need to implement native_to_pa_array_override in tensor_buffer_ext.py
